unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, msxml_tlb, ImgList;
const
        NOTA=1;
        POMLKA=2;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Button1: TButton;
    od: TOpenDialog;
    ImageList1: TImageList;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  gallery:string;
  elementslens:array of variant; //delky not/pomlk
elementstypes:array of integer;  //nota nebo pomlka?
elementsattrs:array of string; //vyska noty
delkataktu:string;
xpos:integer; //aktualni pozice v notove osnove
notex:integer; //sirka jedne noty
implementation

{$R *.dfm}

//vykreslime notu o vysce(which) a delce len do image, dist je vzdalenost linek osnovy
procedure drawnote(which:string;len:string;image:timage;dist:integer);
var
b:tbitmap;
delka:real;
pul:boolean;
dolu:boolean;
krizek:boolean;
cypos,cypos2:integer;
fname:string;
stupnice:string;
stupval:integer;
notady:integer;
tecka:boolean;
posunx:integer;

begin
pul:=false;
delka:=strtoint(len[1]);
tecka:=false;
//kdyz nota ma delku 3 je to 2ka s pulkou
if len='3' then
        begin
                delka:=2;
                tecka:=true;
        end;
//kdyz mame delku 0.5 je to 0(cislo obrazku)        
if len='0.5' then
        delka:=0;


if length(len)>1 then
        pul:=true;
if length(which)>1 then
        krizek:=true
else
        krizek:=false;
//pokud mame VELKE noty nozicka nejde dolu
if which[1] in ['C','D','E','F','G','A','H'] then
        dolu:=false
else
        dolu:=true;
fname:='nota_';
if delka=4 then
        fname:=fname+'4'
else
        begin
                if krizek then
                        fname:=fname+'krizek_';
                if dolu then
                        fname:=fname+'dolu_'
                else
                        fname:=fname+'nahoru_';
                fname:=fname+inttostr(round(delka));
        end;
//nacteme obrazek noty
b:=tbitmap.Create;
b.LoadFromFile(gallery+fname+'.bmp');
b.Transparent:=true;

//najdeme pozici C
cypos:=(image.Height div 2)+ dist*4-dist div 2;

//kdyz mame krizkovane a noty dolu musime to upravit
if krizek then
        cypos:=cypos+b.Height div 6;
if krizek and dolu then
        cypos:=cypos-b.Height div 3;
if (not dolu) or (delka=4) then
        cypos:=cypos-b.Height
else
        cypos:=cypos-dist-dist div 2;

//zjisteni vzdalenosti noty od C        
stupnice:='CDEFGAHcdefgah';
stupval:=pos(which[1],stupnice)-1;
//o kolik na y musime posunout notu?
notady:=(dist div 2)*stupval;
b.TransparentColor:=clWhite;
b.Transparent:=true;

//kdyz mame celou notu, musime vycentrovat pozici protoze je jina nez u not s nozickou
if delka=4 then
        cypos:=cypos-b.Height div 2-b.Height div 2;


if tecka then
        delka:=delka+0.5;
if delka=0 then
        delka:=0.5;
//vypocitame o kolik se musime posunout na x(podle delky noty)        
posunx:=round(notex*delka);
if not dolu then
        cypos2:=cypos+b.Height-b.Height div 6-notady
else
        cypos2:=cypos-b.Height*2;
if krizek then
        cypos2:=cypos2-b.Height div 6;

if krizek and dolu then
        cypos2:=cypos2+b.Height div 2+b.Height div 4;
//vykreslime tecku        
if tecka then
        begin
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+6,cypos2+1]:=clBlack;
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+5,cypos2]:=clBlack;
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+6,cypos2]:=clBlack;
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+5,cypos2+1]:=clBlack;
        end;
//vykreslime notu        
image.Canvas.Draw(xpos+posunx div 2,cypos-notady,b);
//kresleni cary pro noty pod/nad osnovou
if (stupval=0) then
        begin
                if delka=4 then
                        cypos2:=cypos2-b.Height div 2;
                image.Canvas.moveTo(xpos+posunx div 2-2,cypos2);
                image.Canvas.lineTo(xpos+posunx div 2+b.Width+2,cypos2);
        end;
if  (stupval=13) then
        begin
                image.Canvas.moveTo(xpos+posunx div 2-2,cypos2+b.Height div 6);
                image.Canvas.lineTo(xpos+posunx div 2+b.Width+2,cypos2+b.Height div 6);
        end;
if  (stupval=12) then
        begin
                image.Canvas.moveTo(xpos+posunx div 2-2,cypos2+b.Height div 6);
                image.Canvas.lineTo(xpos+posunx div 2+b.Width+2,cypos2+b.Height div 6);
        end;
//posuneme se dal        
xpos:=xpos+posunx;
end;





procedure drawpomlka(which:string;len:string;image:timage;dist:integer);
var
b:tbitmap;
delka:real;
pul:boolean;
dolu:boolean;
krizek:boolean;
cypos,cypos2:integer;
fname:string;
stupnice:string;
stupval:integer;
notady:integer;
tecka:boolean;
posunx:integer;
begin
pul:=false;
delka:=strtoint(len[1]);
tecka:=false;
//kdyz pomlka ma delku 3 je to 2ka s pulkou
if len='3' then
        begin
                delka:=2;
                tecka:=true;
        end;
//kdyz pomlka ma delku 0.5 je to 0(obrazek)        
if len='0.5' then
        delka:=0;


if length(len)>1 then
        pul:=true;


fname:='pomlka_';
if delka=4 then
        fname:=fname+'4'
else
        begin
                fname:=fname+inttostr(round(delka));
        end;

//nacteni obrazku        
b:=tbitmap.Create;
b.LoadFromFile(gallery+fname+'.bmp');
b.TransparentColor:=clWhite;
b.Transparent:=true;

//vycentrovani
cypos:=(image.Height div 2)-b.Height div 2;

cypos2:=cypos;

if tecka then
        delka:=delka+0.5;
if delka=0 then
        delka:=0.5;

//posun na X podle delky        
posunx:=round(notex*delka);
//vykresl.tecky
if tecka then
        begin
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+6,cypos2+1]:=clBlack;
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+5,cypos2]:=clBlack;
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+6,cypos2]:=clBlack;
                image.Canvas.Pixels[xpos+posunx div 2+b.Width+5,cypos2+1]:=clBlack;
        end;
image.Canvas.Draw(xpos+posunx div 2 - b.Width div 2,cypos,b);
xpos:=xpos+posunx;
end;
//kresleni taktove cary
procedure drawtakt(image:timage);
begin
        xpos:=xpos+15;
        image.Canvas.MoveTo(xpos,0);
        image.Canvas.LineTo(xpos,image.Height);
        xpos:=xpos+15;        
end;




//vykreslime noty ktere mame nactene
procedure draw(image:timage);
var i,y:integer;
btmp2,btmp:tbitmap;
ypos:integer;
delta:integer;
dist:integer;
takt:integer;
act_takt:real;

begin
//nacteme klic a vypociatme zakladni konstanty
btmp:=tbitmap.create;
btmp.LoadFromFile(gallery+'klic.bmp');
delta:=((btmp.Height mod 5)div 2);
notex:=btmp.Width+20;
dist:=(btmp.Height div 5); //vzdalenost mezi carami
ypos:=image.Height div 2 - (6*dist) div 2;

//kresleni osnovy
for i:=1 to 5 do
begin
        image.Canvas.MoveTo(0,dist*i+ypos+delta);
        image.Canvas.LineTo(image.Width,dist*i+ypos+delta);
end;

btmp.Transparent:=true;

//kresleni housl.klice
image.Canvas.Draw(0,image.Height div 2 - btmp.Height div 2,btmp);

//nacteni obr.taktu
btmp2:=tbitmap.create;
btmp2.Transparent:=true;
btmp2.LoadFromFile(gallery+'takt_'+delkataktu[1]+'.bmp');
image.Canvas.Draw(btmp.Width+5,image.Height div 2 - btmp2.Height div 2,btmp2);
xpos:=btmp.Width+5+btmp2.width;
xpos:=xpos+10;
takt:=strtoint(delkataktu[1]);
act_takt:=takt;
for i:=0 to length(elementstypes)-1 do
        begin
                application.ProcessMessages;
                //kreslime notu nebo pomlku?   
                if elementstypes[i]=NOTA then
                        begin
                                //kdyz je takt delsi jak kreslena nota, notu vykreslime a takt zkratime
                                if act_takt >= strtofloat(elementslens[i]) then
                                        begin
                                                elementslens[i]:=strtofloat(elementslens[i]);
                                                drawnote(elementsattrs[i],elementslens[i],image,dist);
                                                act_takt:=act_takt-elementslens[i];

                                        end
                                else  //kdyz ne, notu delime a vyplnujeme ji takty dokud nemuzem pokracovat dal
                                        begin
                                                elementslens[i]:=strtofloat(elementslens[i]);
                                                while act_takt < elementslens[i] do
                                                        begin
                                                                drawnote(elementsattrs[i],floattostr(act_takt),image,dist);
                                                                elementslens[i]:=(elementslens[i])-act_takt;
                                                                act_takt:=takt;
                                                                drawtakt(image);
                                                                

                                                        end;
                                                drawnote(elementsattrs[i],elementslens[i],image,dist);
                                                act_takt:=act_takt-elementslens[i];

                                        end;

                        end
                else
                        begin   //dokud je pomlka delsi nez takt, tak ji kratime a vyplnujeme takty
                                elementslens[i]:=strtofloat(elementslens[i]);
                                               while act_takt < elementslens[i] do
                                                        begin
                                                                drawpomlka(elementsattrs[i],floattostr(act_takt),image,dist);
                                                                elementslens[i]:=(elementslens[i])-act_takt;
                                                                act_takt:=takt;

                                                                drawtakt(image);


                                                        end;
                                                drawpomlka(elementsattrs[i],elementslens[i],image,dist);
                                                act_takt:=act_takt-elementslens[i];
                        end;
                 //kdyz mame konec taktu nakreslime takt.caru       
                 if act_takt=0 then
                                        begin
                                                act_takt:=takt;

                                                drawtakt(image);
                                                
                                        end;

        end;

{

drawnote('D','1',xpos+20,image,dist);
drawnote('E','2',xpos+40,image,dist);
drawnote('F','2',xpos+60,image,dist);
drawnote('G','4',xpos+80,image,dist);
drawnote('A','4',xpos+100,image,dist);
drawnote('H','4',xpos+120,image,dist);
drawnote('c','4',xpos+140,image,dist);
drawnote('d','4',xpos+160,image,dist);
drawnote('e','4',xpos+180,image,dist);
drawnote('f','4',xpos+200,image,dist);
drawnote('g','4',xpos+220,image,dist);
}
end;


procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
xmlsoubor:msxml_tlb.IXMLDOMDocument;
skladba:ixmldomnodelist;
celkem:integer;
noty:ixmldomnodelist;
pomlky:ixmldomnodelist;
elms:ixmldomnodelist;
begin
//vymazani plochy na kresleni
image1.Canvas.Rectangle(0,0,image1.Width,image1.Height);
try     
        if od.execute then
        begin
                //nacteme dokument
                xmlsoubor:=msxml_tlb.CoDOMDocument.Create;
                xmlsoubor.load(od.FileName);
                //element skladby
                skladba:=xmlsoubor.selectNodes('//skladba');
                //vsechny elementy pod skladbou
                elms:=xmlsoubor.selectNodes('//skladba/');

                celkem:=elms.length-1; //celk.pocet elementu

                //nastaveni dynamickych poli
                setlength(elementslens,celkem);
                setlength(elementstypes,celkem);
                setlength(elementsattrs,celkem);

                //projdeme nody a naplnime jimi pole
                for i:=0 to celkem do
                        begin
                                
                                if elms.item[i].nodeName = 'skladba' then
                                        begin
                                                delkataktu:=elms.item[i].attributes.getNamedItem('takt').text;
                                        end;
                                if elms.item[i].nodeName = 'nota' then
                                        begin

                                                elementslens[i-1]:=elms.item[i].attributes.getNamedItem('delka').nodeTypedValue;
                                                elementsattrs[i-1]:=elms.item[i].attributes.getNamedItem('vyska').text;
                                                elementstypes[i-1]:=NOTA;
                                        end;
                                if elms.item[i].nodeName = 'pomlka' then
                                        begin
                                                elementslens[i-1]:=elms.item[i].attributes.getNamedItem('delka').nodeTypedValue;
                                                elementstypes[i-1]:=POMLKA;
                                                
                                        end;
                        end;


        end;
except
        showmessage('Nepodarilo se nacist soubor. Nejspise ma spatny format');
end;
draw(image1);

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
DecimalSeparator:='.';
gallery:=ExtractFilePath(Paramstr(0))+'\bmp\';

button1.OnClick(sender);

end;

end.
